#!/usr/bin/env python3
# -*- coding: utf-8 -*-

""" Mapycs (Matics Python API) usage example """

import json
import mapycs


def main():

    """ Display the full formats list """

#    formats = mapycs.Dataframe.get_formats()
#    print(json.dumps(formats, indent=4))
#    print('-' * 80)
#    print(json.dumps(formats["stm"], indent=4))

    evals = mapycs.Eval.evals()
    print(json.dumps(evals, indent=4, ensure_ascii=False))

    for eva in evals.keys():
        print('=' * 80)
        params = mapycs.Eval.eval_params(eva)
        print(params["name"] + " (" + eva + ")")
        print('-' * 80)
        print("Metrics:")
#        print(json.dumps(params, indent=4, ensure_ascii=False))
        if "metrics" in params:
            for m in params["metrics"]:
                print('\t' + '-' * 16)
                if isinstance(m, list):
                    for mm in m:
                        print("\t" + mm["id"] + " (" + mm["desc"] + ")")
                else:
                    print("\t" + m["id"] + " (" + m["desc"] + ")")
        print('-' * 80)
        print("Params:")
#        print(json.dumps(params, indent=4, ensure_ascii=False))
        if "params" in params:
            for m in params["params"]:
                if isinstance(m, list):
                    for mm in m:
                        print("\t" + mm["id"] + " (" + mm["desc"] + ")")
                else:
                    print("\t" + m["id"] + " (" + m["desc"] + ")")
                    print("\t\tType: " + m["type"])
                    print("\t\tDefault value: " + m["default"])


if __name__ == "__main__":

    main()
