#ifndef P3DF_H
#define P3DF_H

#include "python3.h"

namespace p3 {
struct dataframe {
    PyObject ob_base;
    static PyTypeObject *ptype;
    static PyMethodDef methods[];

    Dataframe *df;
    bool delete_df;

    dataframe() { df = nullptr; delete_df = true; }
    dataframe(Dataframe *_df) { df = _df; delete_df = false; }
    ~dataframe() { if(df && delete_df) delete df; }

    void set(Dataframe *_df) { if(df && delete_df) delete df; df = _df; }

    static bool reg(PyObject *module);

    static std::unique_ptr<bson::document> parse_params(PyObject *params);

    static int init(PyObject *, PyObject *, PyObject *);
    static PyObject *str(PyObject *);

    static bool get_linecol(PyObject *args, Dataframe *df, int &line, int &col);

    static PyObject *get_formats(PyObject *, PyObject *);
    static PyObject *from_file(PyObject *, PyObject *);
    static PyObject *load_annot(PyObject *, PyObject *);
    static PyObject *load_annot_with_format(PyObject *, PyObject *);
    static PyObject *save(PyObject *, PyObject *);
    static PyObject *normalize(PyObject *, PyObject *);
    static PyObject *add_medias(PyObject *, PyObject *);
    static PyObject *get_lines_count(PyObject *, PyObject *);
    static PyObject *get_cols_count(PyObject *, PyObject *);
    static PyObject *get_cols_keys(PyObject *, PyObject *);
    static PyObject *get_val_val_num(PyObject *, PyObject *);
    static PyObject *get_val_val_str(PyObject *, PyObject *);
    static PyObject *get_val_lab_num(PyObject *, PyObject *);
    static PyObject *get_val_lab_str(PyObject *, PyObject *);
    static PyObject *get_val_line(PyObject *, PyObject *);
    static PyObject *get_val_expr(PyObject *, PyObject *);
    static PyObject *get_val(PyObject *, PyObject *);
};
}

#endif
