#ifndef P3EVAL_H
#define P3EVAL_H

#include "python3.h"

#include <Evaluations/eval.h>

namespace p3 {
struct eval {
    PyObject ob_base;
    static PyTypeObject *ptype;
    static PyMethodDef methods[];

    Eval *eva;
    bool delete_eva;

    std::list<PyObject*>        dtfs;
    std::string                 err;

    eval() { eva = nullptr; delete_eva = true; }
    eval(Eval *_df) { eva = _df; delete_eva = false; }
    ~eval()
    {
        if(eva && delete_eva) delete eva;
        for (auto dtf : dtfs)
            Py_DecRef(dtf);
    }
    void set(Eval *_eva) { if(eva && delete_eva) delete eva; eva = _eva; }

    static bool reg(PyObject *module);

    static int init(PyObject *, PyObject *, PyObject *);
    static PyObject *str(PyObject *);

    static PyObject *evals(PyObject *, PyObject *);
    static PyObject *eval_params(PyObject *, PyObject *);

    static PyObject *get_dtfs(PyObject *, PyObject *);
    static PyObject *get_res_df(PyObject *, PyObject *);

    static PyObject *get_err(PyObject *, PyObject *);
};
}

#endif // P3EVAL_H
