#include "p3medialoader.h"

#include <sys/stat.h>
#include <filesystem>

p3::MediaLoader* p3::MediaLoader::instance= nullptr;;

p3::MediaLoader::MediaLoader()
{

}

p3::MediaLoader *p3::MediaLoader::get_instance()
{
    if(instance==nullptr){
        instance = new MediaLoader();
    }
    return instance;
}

std::string p3::MediaLoader::immediate_access(Dataframe *df, int line, int col)
{
    // Column value
    std::string     dtf_path = df->getValueLabStr(line, col);

    // Base file name
    auto        file_name = std::filesystem::path(dtf_path).filename().replace_extension().string();
//    std::cout << dtf_path << " : " << file_name << std::endl;


    // Check the actual path
    struct stat     statbuf;
    if (stat(dtf_path.c_str(), &statbuf) == -1)
    {
        // Not found, check in the file name map
        auto            entry = entries_map.find(file_name);

        // No entry
        if (entry == entries_map.end())
            return "";

        // Found
        return entry->second;
    }
    // Add to map
    entries_map.insert(std::pair<std::string, std::string>(file_name, dtf_path));

    // We're good
//    std::cout << dtf_path << std::endl;
    return dtf_path;
}

MediaFile *p3::MediaLoader::immediate_access_mf(Dataframe *df, int line, int col)
{
    if(df->isEmptyValue(line, col))
        return nullptr;
    std::string name = df->getValueLabStr(line, col);
    try {
        return new MediaFile(name);
    } catch(...) {
        return nullptr;
    }
}
