#include "python3.h"
#include "p3df.h"
#include "p3cs.h"
#include "p3eval.h"
#include "p3det.h"

#include <mapycs.h>

namespace p3 {
static int exec(PyObject *module)
{
    if(dataframe::reg(module)) return 1;
    if(catstruct::reg(module)) return 1;
    if(eval::reg(module)) return 1;
    if(det::reg(module)) return 1;
    PyObject *g = PyDict_New();
    auto res = PyRun_String(mapycs_text, Py_file_input, g, PyModule_GetDict(module));
    Py_DECREF(res);
    Py_DECREF(g);
    return 0;
}

static PyMethodDef methods[] = {
  { }
};

static PyModuleDef_Slot slot[] = {
  { Py_mod_exec, reinterpret_cast<void *>(exec) },
  { 0, nullptr }
};

static PyModuleDef module = {
    PyModuleDef_HEAD_INIT,
    "Mapycs",
    nullptr, // doc
    0,       // size
    methods,
    slot,
    nullptr,
    nullptr,
    nullptr
};
}

PyMODINIT_FUNC PyInit_mapycs()
{
    return PyModuleDef_Init(&p3::module);
}
